liebherr = {}

function liebherr.prerequisitesPresent(specializations)
     Vehicle.registerJointType("shovel");
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function liebherr:load(xmlFile)
 self.frontlight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.frontlight#index"));
    --setVisibility(self.frontlight, false);

 self.braslight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.braslight#index"));
   -- setVisibility(self.braslight, false);

 self.backlight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.backlight#index"));
   -- setVisibility(self.backlight, false); 

 self.codelight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.codelight#index"));
    --setVisibility(self.codelight, false);





    
    local numexhaustParticleSystem = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.exhaustParticleSystem#count"), 0);
    self.exhaustParticleSystem = {};
    for i=1, numexhaustParticleSystem do
        local namei = string.format("vehicle.exhaustParticleSystem.exhaustParticleSystem%d", i);
		local nodei = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#node"));
        Utils.loadParticleSystem(xmlFile, self.exhaustParticleSystem, namei, nodei, false, nil, self.baseDirectory)		
        setVisibility(self.exhaustParticleSystem[i], false);
    end;
    
    local numexhaustParticleSyste = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.exhaustParticleSyste#count"), 0);
    self.exhaustParticleSyste = {};
    for i=1, numexhaustParticleSyste do
        local namei = string.format("vehicle.exhaustParticleSyste.exhaustParticleSystem%d", i);
		local nodei = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#node"));
        Utils.loadParticleSystem(xmlFile, self.exhaustParticleSyste, namei, nodei, false, nil, self.baseDirectory)		
        setVisibility(self.exhaustParticleSyste[i], false);
    end;
    
    self.translationMax = false;
    self.translationMax2 = false;
    
        local motoSound = getXMLString(xmlFile, "vehicle.motoSound#file");
       if motoSound ~= nil and motoSound ~= "" then
           motoSound = Utils.getFilename(motoSound, self.baseDirectory);
           self.motoSound = createSample("motoSound");
           loadSample(self.motoSound, motoSound, false);
           self.motoSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motoSound#pitchOffset"), 0);
           self.motoSoundPitchScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motoSound#pitchScale"), 0.05);
           self.motoSoundPitchMax = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motoSound#pitchMax"), 2.0);
           self.motoSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motoSound#volume"), 1.0);
           self.motoSoundEnabled = false;
       end;
       
    local chenilleSound = getXMLString(xmlFile, "vehicle.chenilleSound#file");
       if chenilleSound ~= nil and chenilleSound ~= "" then
           chenilleSound = Utils.getFilename(chenilleSound, self.baseDirectory);
           self.chenilleSound = createSample("chenilleSound");
           loadSample(self.chenilleSound, chenilleSound, false);
           self.chenilleSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.chenilleSound#pitchOffset"), 0);
           self.chenilleSoundPitchScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.chenilleSound#pitchScale"), 0.05);
           self.chenilleSoundPitchMax = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.chenilleSound#pitchMax"), 2.0);
           self.chenilleSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.chenilleSound#volume"), 1.0);
           self.chenilleSoundEnabled = false;
       end;
       
    local translationPartNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart#index"));
    if translationPartNode ~= nil then
        self.translationPart = {};
        self.translationPart.node = translationPartNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart#minTrans"));
        self.translationPart.minTrans = {};
        self.translationPart.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart#maxTrans"));
        self.translationPart.maxTrans = {};
        self.translationPart.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart#transTime"), 2)*1000;
        self.translationPart.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart#touchTransLimit"), 10);
    end;
    local translationPartNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart2#index"));
    if translationPartNode2 ~= nil then
        self.translationPart2 = {};
        self.translationPart2.node = translationPartNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#minTrans"));
        self.translationPart2.minTrans = {};
        self.translationPart2.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#maxTrans"));
        self.translationPart2.maxTrans = {};
        self.translationPart2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#transTime"), 2)*1000;
        self.translationPart2.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#touchTransLimit"), 10);
    end;
    
    	
 self.regime = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.regime#index"));
 self.regime2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.regime2#index"));
	


     local hidraulicSound = getXMLString(xmlFile, "vehicle.hidraulicSound#file");
    if hidraulicSound ~= nil and hidraulicSound ~= "" then
        hidraulicSound = Utils.getFilename(hidraulicSound, self.baseDirectory); 
        self.hidraulicSound = createSample("hidraulicSound");
        loadSample(self.hidraulicSound, hidraulicSound, false);
        self.hidraulicSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.hidraulicSound#pitchOffset"), 1);
        self.hidraulicSoundPitchScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.hidraulicSound#pitchScale"), 0);
        self.hidraulicSoundPitchMax = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.hidraulicSound#pitchMax"), 2.0);
    end;
   

  

   
    
    local rotationPartNodetourelle = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tourelle#index"));
    if rotationPartNodetourelle ~= nil then
        self.tourelle = {};
        self.tourelle.node = rotationPartNodetourelle;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tourelle#minRot"));
        self.tourelle.minRot = {};
        self.tourelle.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.tourelle.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.tourelle.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tourelle#maxRot"));
        self.tourelle.maxRot = {};
        self.tourelle.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.tourelle.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.tourelle.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.tourelle.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.tourelle#rotTime"), 2)*1000;
        self.tourelle.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.tourelle#touchRotLimit"), 10))
    end;
  
    
    local rotationPartNodebras2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bras2#index"));
    if rotationPartNodebras2 ~= nil then
        self.bras2 = {};
        self.bras2.node = rotationPartNodebras2;  

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.bras2#minRot"));
        self.bras2.minRot = {};
        self.bras2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.bras2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.bras2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.bras2#maxRot"));
        self.bras2.maxRot = {};
        self.bras2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.bras2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.bras2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.bras2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.bras2#rotTime"), 2)*1000;
     
     
	    self.bras2.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bras2#pivotverin"));
    end;

 
    local rotationPartNodebras1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bras1#index"));
    if rotationPartNodebras1 ~= nil then
        self.bras1 = {};
        self.bras1.node = rotationPartNodebras1;
        

		
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.bras1#minRot"));
        self.bras1.minRot = {};
        self.bras1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.bras1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.bras1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.bras1#maxRot"));
        self.bras1.maxRot = {};
        self.bras1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.bras1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.bras1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.bras1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.bras1#rotTime"), 2)*1000;
     
     
	    self.bras1.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bras1#pivotverin"));
    end;
    
    local transformer1Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.transformer#index"));
    if transformer1Node ~= nil then
        self.transformer = {};
        self.transformer.node = transformer1Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.transformer#minRot"));
        self.transformer.minRot = {};
        self.transformer.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.transformer.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.transformer.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.transformer#maxRot"));
        self.transformer.maxRot = {};
        self.transformer.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.transformer.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.transformer.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));


		self.transformer.rotTime = self.workingArm.rotTime;


		self.transformer.fixPoint = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.transformer#fixPoint"));

    end;

    local rotationPartNodeworkingArm2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.workingArm2#index"));
    if rotationPartNodeworkingArm2 ~= nil then
        self.workingArm2 = {};
        self.workingArm2.node = rotationPartNodeworkingArm2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.workingArm2#minRot"));
        self.workingArm2.minRot = {};
        self.workingArm2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.workingArm2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.workingArm2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.workingArm2#maxRot"));
        self.workingArm2.maxRot = {};
        self.workingArm2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.workingArm2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.workingArm2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.workingArm2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.workingArm2#rotTime"), 2)*1000;


	    self.workingArm2.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.workingArm2#pivotverin"));
    end;

    local rotationPartNodeworkingArm3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.workingArm3#index"));
    if rotationPartNodeworkingArm3 ~= nil then
        self.workingArm3 = {};
        self.workingArm3.node = rotationPartNodeworkingArm3;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.workingArm3#minRot"));
        self.workingArm3.minRot = {};
        self.workingArm3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.workingArm3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.workingArm3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.workingArm3#maxRot"));
        self.workingArm3.maxRot = {};
        self.workingArm3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.workingArm3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.workingArm3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.workingArm3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.workingArm3#rotTime"), 2)*1000;


	    self.workingArm3.pivotverin = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.workingArm3#pivotverin"));
    end;



    self.hydraulicMainArm = {};
	self.hydraulicMainArm.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hydraulicMainArm#indexHydraulic"));
	self.hydraulicMainArm.punch = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hydraulicMainArm#indexPunch"));
	self.hydraulicMainArm.translationPunch = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hydraulicMainArm#translationPunch"));
	local ax, ay, az = getWorldTranslation(self.hydraulicMainArm.punch);
    local bx, by, bz = getWorldTranslation(self.hydraulicMainArm.translationPunch);
    self.hydraulicMainArm.punchDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);


    self.bielle1 = {};
	self.bielle1.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bielle1#indexverin"));
	self.bielle1.tige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bielle1#indextige"));
	self.bielle1.translationtige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.bielle1#translationtige"));
	local ax, ay, az = getWorldTranslation(self.bielle1.tige);
    local bx, by, bz = getWorldTranslation(self.bielle1.translationtige);
    self.bielle1.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
    

    
   
	
    self.verin2 = {};
	self.verin2.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin2#indexverin"));
	self.verin2.tige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin2#indextige"));
	self.verin2.translationtige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin2#translationtige"));
	local ax, ay, az = getWorldTranslation(self.verin2.tige);
    local bx, by, bz = getWorldTranslation(self.verin2.translationtige);
    self.verin2.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
    
    self.verin1 = {};
	self.verin1.node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin1#indexverin"));
	self.verin1.tige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin1#indextige"));
	self.verin1.translationtige = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.verin1#translationtige"));
	local ax, ay, az = getWorldTranslation(self.verin1.tige);
    local bx, by, bz = getWorldTranslation(self.verin1.translationtige);
    self.verin1.tigeDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
    
  
    
    
    
	local objectAttacher = {};
	objectAttacher.joint = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.anchor#index"));
	objectAttacher.index = 0;
	self.object = objectAttacher;
	self.attachedObject = nil;
	self.objectAttachable = false;
	self.objectInRange = nil;

    
	
    self.fillScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.fillScale#value"), 1);
	self.name = Utils.getNoNil(getXMLString(xmlFile, "vehicle.name."..g_languageShort), "Objekt");
	


	

	
end;

function liebherr:delete()
   if self.hidraulicSound ~= nil then
        delete(self.hidraulicSound);
    end;
    Utils.deleteParticleSystem(self.exhaustParticleSystems);
    Utils.deleteParticleSystem(self.exhaustParticleSystem);
    Utils.deleteParticleSystem(self.exhaustParticleSyste);
end;

function liebherr:readStream(streamId, connection)
      if self.workingArmNode ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.workingArmNode.node, x, y, z);
      end;
     if self.transformer ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.transformer.node, x, y, z);
      end;

    if self.tourelle ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.tourelle.node, x, y, z);
      end;

   if self.bras2 ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.bras2.node, x, y, z);
      end;
   if self.bras1 ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.bras1.node, x, y, z);
      end;
      if self.workingArm2 ~= nil then
          local x = streamReadFloat32(streamId);
          local y = streamReadFloat32(streamId);
          local z = streamReadFloat32(streamId);
         setRotation(self.workingArm2.node, x, y, z);
      end;
end;
  
function liebherr:writeStream(streamId, connection)
     
     if self.workingArmNode ~= nil then
          local x, y, z = getRotation(self.workingArmNode.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
      if self.transformer ~= nil then
          local x, y, z = getRotation(self.transformer.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
      if self.tourelle ~= nil then
          local x, y, z = getRotation(self.tourelle.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
      if self.bras2 ~= nil then
          local x, y, z = getRotation(self.bras2.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
      if self.bras1 ~= nil then
          local x, y, z = getRotation(self.bras1.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
      if self.workingArm2 ~= nil then
          local x, y, z = getRotation(self.workingArm2.node);
          streamWriteFloat32(streamId, x);
          streamWriteFloat32(streamId, y);
          streamWriteFloat32(streamId, z);
      end;
end;



function liebherr:mouseEvent(posX, posY, isDown, isUp, button)
end;

function liebherr:keyEvent(unicode, sym, modifier, isDown)    


  
end;
function liebherr:update(dt)

	   	for i, jointDesc in pairs(self.componentJoints) do
	   setJointFrame(self.componentJoints[i].jointIndex, 0, self.componentJoints[i].jointNode);
	end;


		if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
			self.translationMax2 = not self.translationMax2;
		end;

	
	
	if self.translationMax2 then
		Utils.setEmittingState(self.exhaustParticleSyste, true)
	else
		Utils.setEmittingState(self.exhaustParticleSyste, false)
	end;
	
	if self.translationMax ~= nil then
		local x, y, z = getTranslation(self.translationPart.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart.maxTrans, self.translationPart.minTrans, 3, self.translationPart.transTime, dt, not self.translationMax);
        setTranslation(self.translationPart.node, unpack(newTrans));
	end;
	
	if self.translationMax2 ~= nil then
		local x, y, z = getTranslation(self.translationPart2.node);
        local trans = {x,y,z};
        local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart2.maxTrans, self.translationPart2.minTrans, 3, self.translationPart2.transTime, dt, not self.translationMax2);
        setTranslation(self.translationPart2.node, unpack(newTrans));
	end;

    	if self.isMotorStarted then
			if self:getIsActiveForSound() then
               if self.motoSound ~= nil and not self.motoSoundEnabled then
                   playSample(self.motoSound, 0, self.motoSoundVolume, 0);
                   self.motoSoundEnabled = true;
               end;
             
          
			end;
			local x,y,z = getWorldTranslation(self.regime);
			local a,b,c = getWorldTranslation(self.regime2);
			local benne = Utils.vector3Length(x-a, y-b, z-c);
            if self.motoSound ~= nil then
                setSamplePitch(self.motoSound, math.min(self.motoSoundPitchOffset + self.motoSoundPitchScale*math.abs(benne), self.motoSoundPitchMax));
            end;
		end;
		
	if self.movingDirection == 1 or self.movingDirection == -1 then	
		if table.getn(self.wheels) > 0 then
               local alpha = 0.9;
               local roundPerMinute = self.lastRoundPerMinute*alpha + (1-alpha)*(self.motor.lastMotorRpm-self.motor.minRpm);
               self.lastRoundPerMinute = roundPerMinute;
               local roundPerSecond = roundPerMinute / 40;
               
		if self.isMotorStarted then
			if self:getIsActiveForSound() then
               if self.chenilleSound ~= nil and not self.chenilleSoundEnabled then
                   playSample(self.chenilleSound, 0, self.chenilleSoundVolume, 0);
                   self.chenilleSoundEnabled = true;
               end;
			end;
            if self.chenilleSound ~= nil then
                setSamplePitch(self.chenilleSound, math.min(self.chenilleSoundPitchOffset + self.chenilleSoundPitchScale*math.abs(roundPerSecond+3), self.chenilleSoundPitchMax));
            end;
		end;
		end;
	else if self.chenilleSound ~= nil and self.chenilleSoundEnabled then
        stopSample(self.chenilleSound);
        self.chenilleSoundEnabled = false;
    end;
		 end;
		 
	if self.movingDirection == 1 or self.movingDirection == -1 then	
		if table.getn(self.wheels) > 0 then
            local alpha = 0.9;
            local roundPerMinute = self.lastRoundPerMinute*alpha + (1-alpha)*(self.motor.lastMotorRpm-self.motor.minRpm);
            self.lastRoundPerMinute = roundPerMinute;
            local x,y,z = getWorldTranslation(self.regime);
			local a,b,c = getWorldTranslation(self.regime2);
			local benne = Utils.vector3Length(x-a, y-b, z-c);
        	local roundPerSecond = (roundPerMinute*benne) / 40;
               
               
	    end;
	end;	 
		 
	if self.movingDirection == 1 or self.movingDirection == -1 or self.rotationMaxworkingArm or self.rotationMinworkingArm or self.rotationMaxbras4 or self.rotationMinbras4  or self.rotationMaxbras1 or self.rotationMinbras1  or self.rotationMaxbras3 or self.rotationMinbras3  or self.rotationMaxbras2 or self.rotationMinbras2  or self.rotationMaxtourelle or self.rotationMintourelle then
		self.translationMax = true;
        Utils.setEmittingState(self.exhaustParticleSystem, true)
    else
        self.translationMax = false;
        Utils.setEmittingState(self.exhaustParticleSystem, false)
	end;
	
	if self.rotationMaxworkingArm or self.rotationMinworkingArm or self.rotationMaxbras4 or self.rotationMinbras4  or self.rotationMaxbras1 or self.rotationMinbras1  or self.rotationMaxbras3 or self.rotationMinbras3  or self.rotationMaxbras2 or self.rotationMinbras2 then
		self.playHidraulic4 = true;
    else
        self.playHidraulic4 = false;
	end;

		
		
if self:getIsActive() and self.isClient then
    if self.isEntered and self.isMotorStarted then
       if self.playHidraulic or self.playHidraulic1 or self.playHidraulic2 or self.playHidraulic3 or self.playHidraulic4 or self.playHidraulic5 or self.playHidraulic6 or self.playHidraulic7 then
            if self.hidraulicSound ~= nil and not self.hidraulicSoundEnabled then
                if self:getIsActiveForSound() then
                    setSamplePitch(self.hidraulicSound, self.hidraulicSoundPitchOffset);
                    playSample(self.hidraulicSound, 0, 0.5, 0);
                    self.hidraulicSoundEnabled = true;
                end;
            end;
     
	
        else
            if self.hidraulicSound ~= nil and self.hidraulicSoundEnabled then
                stopSample(self.hidraulicSound);
                self.hidraulicSoundEnabled = false;
            end;
     
	end;
   end;



     if self.braslightActive then
				local braslights = self.braslight;
				setVisibility(braslights, self.braslightActive);
		    else
     			local braslights = self.braslight;
				---setVisibility(braslights, self.braslightActive, false);
	end;

    if self.backlightActive then
				local backlights = self.backlight;
				setVisibility(backlights, self.backlightActive);
		    else
     			local backlights = self.backlight;
				---setVisibility(backlights, self.backlightActive, false);
	end;

   if self.codelightActive then
				local codelights = self.codelight;
				setVisibility(codelights, self.codelightActive);
		    else
     			local codelights = self.codelight;
				---setVisibility(codelights, self.codelightActive, false);
	end;






        if self.isEntered == nil then
	        stopSample(self.motorMBSound);
	end;


	local doRotate = self.rotationMaxtourelle or self.rotationMintourelle
    	if self.tourelle ~= nil and doRotate then
    	local x,y,z = getWorldTranslation(self.regime);
		local a,b,c = getWorldTranslation(self.regime2);
		local benne = Utils.vector3Length(x-a, y-b, z-c);
		local x, y, z = getRotation(self.tourelle.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.tourelle.maxRot, self.tourelle.minRot, 3, self.tourelle.rotTime*(9/benne), dt, not self.rotationMaxtourelle);
		setRotation(self.tourelle.node, unpack(newRot));		
	end;
	
   
	
   	local doRotate = self.rotationMaxbras2 or self.rotationMinbras2
    	if self.bras2 ~= nil and doRotate then
    	local x,y,z = getWorldTranslation(self.regime);
		local a,b,c = getWorldTranslation(self.regime2);
		local benne = Utils.vector3Length(x-a, y-b, z-c);
		local x, y, z = getRotation(self.bras2.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.bras2.maxRot, self.bras2.minRot, 3, self.bras2.rotTime*(9/benne), dt, not self.rotationMaxbras2);
		setRotation(self.bras2.node, unpack(newRot));
		
	end;
	
   	local doRotate = self.rotationMaxbras1 or self.rotationMinbras1
    	if self.bras1 ~= nil and doRotate then
    	local x,y,z = getWorldTranslation(self.regime);
		local a,b,c = getWorldTranslation(self.regime2);
		local benne = Utils.vector3Length(x-a, y-b, z-c);
		local x, y, z = getRotation(self.bras1.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.bras1.maxRot, self.bras1.minRot, 3, self.bras1.rotTime*(9/benne), dt, not self.rotationMaxbras1);
		setRotation(self.bras1.node, unpack(newRot));
		
	end;
	
		local doRotate = self.rotationMaxworkingArm2 or self.rotationMinworkingArm2
    if self.workingArm2 ~= nil and doRotate then
        local x,y,z = getWorldTranslation(self.regime);
		local a,b,c = getWorldTranslation(self.regime2);
		local benne = Utils.vector3Length(x-a, y-b, z-c);
		local x, y, z = getRotation(self.workingArm2.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.workingArm2.maxRot, self.workingArm2.minRot, 3, self.workingArm2.rotTime, dt, not self.rotationMaxworkingArm2);
		setRotation(self.workingArm2.node, unpack(newRot));
	end;

	local doRotate = self.rotationMaxworkingArm3 or self.rotationMinworkingArm3
    if self.workingArm3 ~= nil and doRotate then
        local x,y,z = getWorldTranslation(self.regime);
		local a,b,c = getWorldTranslation(self.regime2);
		local benne = Utils.vector3Length(x-a, y-b, z-c);
		local x, y, z = getRotation(self.workingArm3.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.workingArm3.maxRot, self.workingArm3.minRot, 3, self.workingArm3.rotTime, dt, not self.rotationMaxworkingArm3);
		setRotation(self.workingArm3.node, unpack(newRot));
	end;


	if self.hydraulicMainArm ~= nil and self.workingArm3 ~= nil then
		local ax, ay, az = getWorldTranslation(self.hydraulicMainArm.node);
		local bx, by, bz = getWorldTranslation(self.workingArm3.pivotverin);
		local x, y, z = worldDirectionToLocal(getParent(self.hydraulicMainArm.node), bx-ax, by-ay, bz-az);
		setDirection(self.hydraulicMainArm.node, x*-1, y*-1, z*-1, 0, 1, 0);
		if self.hydraulicMainArm.punch ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
		    setTranslation(self.hydraulicMainArm.punch, 0, 0, (distance-self.hydraulicMainArm.punchDistance)*-1);
		end;
	end;


	if self.bielle1 ~= nil and self.workingArm2 ~= nil then
		local ax, ay, az = getWorldTranslation(self.bielle1.node);
		local bx, by, bz = getWorldTranslation(self.workingArm2.pivotverin);
		local x, y, z = worldDirectionToLocal(getParent(self.bielle1.node), bx-ax, by-ay, bz-az);
		setDirection(self.bielle1.node, x*-1, y*-1, z*-1, 0, 1, 0);
		if self.bielle1.tige ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.bielle1.tige, 0, 0, (distance-self.bielle1.tigeDistance)*-1);
		end;
	end;
	



    
	if self.verin2 ~= nil and self.bras2 ~= nil then
		local ax, ay, az = getWorldTranslation(self.verin2.node);
		local bx, by, bz = getWorldTranslation(self.bras2.pivotverin);
		local x, y, z = worldDirectionToLocal(getParent(self.verin2.node), bx-ax, by-ay, bz-az);
		setDirection(self.verin2.node, x*-1, y*-1, z*-1, 0, 1, 0);
		if self.verin2.tige ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.verin2.tige, 0, 0, (distance-self.verin2.tigeDistance)*-1);
		end;
	end;
	if self.verin1 ~= nil and self.bras1 ~= nil then
		local ax, ay, az = getWorldTranslation(self.verin1.node);
		local bx, by, bz = getWorldTranslation(self.bras1.pivotverin);
		local x, y, z = worldDirectionToLocal(getParent(self.verin1.node), bx-ax, by-ay, bz-az);
		setDirection(self.verin1.node, x*-1, y*-1, z*-1, 0, 1, 0);
		if self.verin1.tige ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(self.verin1.tige, 0, 0, (distance-self.verin1.tigeDistance)*-1);
		end;
	end;

end;	
end;

function liebherr:onLeave()
      if self.isClient then
           if self.motoSound ~= nil then
               stopSample(self.motoSound);
               self.motoSoundEnabled = false;

           end;
    if self.chenilleSound ~= nil and self.chenilleSoundEnabled then
        stopSample(self.chenilleSound);
        self.chenilleSoundEnabled = false;

    end;
           
   	    Utils.setEmittingState(self.exhaustParticleSystem, false)
        Utils.setEmittingState(self.exhaustParticleSyste, false)
		self.translationMax2 = false;
       end;
end;  
      


function liebherr:draw()
 -- g_currentMission:addExtraPrintText("Touche KP_1/KP_2: Rotation Tourelle");
  --g_currentMission:addExtraPrintText("Touche KP_7/KP_4/KP_8/KP_5/KP_9/KP_6: Bras");
  g_currentMission:addExtraPrintText("Touche B: regime moteur");   	
end;

function liebherr:onDeactivateSounds()
    if self.hidraulicSound ~= nil and self.hidraulicSoundEnabled then
        stopSample(self.hidraulicSound);
        self.hidraulicSoundEnabled = false;
    end; 
end;



function liebherr:onDeactivate()

    if self.hidraulicSound ~= nil and self.hidraulicSoundEnabled then
        stopSample(self.hidraulicSound);
        self.hidraulicSoundEnabled = false;
        delete(self.hidraulicSound);
    end;
	if self.motoSound ~= nil and self.motoSoundEnabled then
        stopSample(self.motoSound);
        self.motoSoundEnabled = false;
        delete(self.motoSound);
    end;
    if self.chenilleSound ~= nil and self.chenilleSoundEnabled then
        stopSample(self.chenilleSound);
        self.chenilleSoundEnabled = false;
        delete(self.chenilleSound);
    end;
end;


function liebherr:anim(varName, loopCheck)
end;


function liebherr:connectCollisions(varName)
end;



function liebherr:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;

function liebherr:doRotate(index, boolean, dt)
end;